package com.company.bw_emerson_fallah.Stellar;


import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.Scanner;
import org.stellar.sdk.KeyPair;
import org.stellar.sdk.responses.AccountResponse;

/**
 *
 * @author emerson
 */
public class WalletManager {

    private String accountId;
    private String secretSeed;
    private KeyPair key;
    

    /**
     * Wallet constructor with parameter
     *
     * @param key
     */
    public WalletManager(KeyPair key) {
        this.key = key;
    }

    /**
     * Wallet empty constructor
     */
    public WalletManager() {
    }

    /**
     * Account ID getter
     *
     * @return String - Account ID
     */
    public String getAccountId() {
        return accountId;
    }

    /**
     * Account secret seed getter
     *
     * @return String - Accounts Secret Seed
     */
    public String getSecretSeed() {
        return secretSeed;
    }

    /**
     * Account ID setter
     * 
     */
    public void setAccountId() {
        this.accountId = key.getAccountId();
    }

    /**
     * Account secret seed setter
     */
    public void setSecretSeed() {
        this.secretSeed = new String(this.key.getSecretSeed());
    }
    
    
       /**
     * This method activates all new accounts
     */
    public void activateAccount() {
        String url = String.format(StringUtil.STELLAR_BOT, this.getAccountId());
        InputStream response = null;
        try {
            response = new URL(url).openStream();
        } catch (IOException ex) {
            ex.getMessage();
        }
        String body = new Scanner(response, "UTF-8").useDelimiter("\\A").next();
        System.out.println("Account activated: " + body);
    }

    /**
     * This method checks the balance of all newly created account
     * @throws java.io.IOException
     */
    public void checkAccountBalance() throws IOException {
        AccountResponse account = StringUtil.SERVER.accounts().account(this.getAccountId());

        System.out.println("Balances for account " + this.getAccountId());
        for (AccountResponse.Balance balance : account.getBalances()) {
            System.out.println(String.format(
                    "Type: %s, Code: %s, Balance: %s",
                    balance.getAssetType(),
                    balance.getAssetCode(),
                    balance.getBalance()));
        }
    }

}
